BZOJ 2069: [POI2004]ZAW(Dijkstra + 二进制拆分)
题意
给定一个有 \(N\) 个点 \(M\) 条边的无向图, 每条无向边 最多只能经过一次 .
对于边 \((u, v)\) , 从 \(u\) 到 \(v\) 的代价为 \(a\) , 从 \(v\) 到 \(u\) 的代价为 \(b\) , 其中 \(a\) 和 \(b\) 不一定相等.
求一个包含 \(1\) 号点的有向环, 使得环上代价之和最小.
\(N \le 3 \times 10^4 , M \le 10^5 , 1 \le a, b \le 10^4\) , 保证没有重边和自环 .
题解
考虑一条包含 \(1\) 的有向环, 一定是 \(1 \to x \to \cdots \to y \to 1\) 这样子. \((x \not = y)\)
那么我们可以考虑一个很显然的暴力:枚举 \(x, y\) 然后做最短路, 但是这样显然太慢了.
但是这里的最短路是可以 “并行” 地求的. 也就是说, 如果给定两个不相交的点集 \(\mathcal{A}, \mathcal{B}\) , 那么我们可以用一次最短路的时间求出所
有点对 \((x, y)\) 满足 \(x \in \mathcal{A}, y \in \mathcal{B}\) 的最短路的最小值.
具体地, 我们把 \(1\) 号点拆成两个点, 一个作为源点只连向 \(\mathcal{A}\) 中的点, 另一个作为汇点只被 \(\mathcal{B}\) 中的点连向.
然后这里需要一个二进制拆分的技巧: 在与 \(1\) 相邻的那些点中,每次考虑它们二进制下的第 \(k\) 位, 将这一位为 \(0\) 的放入 \(A\) , 为 \(1\) 的放入 \(\mathcal{B}\) , 那么只需 \(\log N\) 次, 我们便可以考虑到每一对.
以上全部摘自 __debug 的 PPT 。
这个最短路可以用 Spfa 求,但实测要比 Dijkstra 慢几倍。。为了求稳,还是用 Dijkstra 吧233
所以最后的复杂度就是 \(\mathcal O((N + M) \log^2 N)\)
总结
对于一类考虑点对贡献,并且很多对可以并行求,且重复计算没有影响的问题,能考虑二进制拆分技巧,对于每一位分别考虑。
将整体分成两组,最后计算贡献,能大幅度降低时间复杂度。
新套路 get
代码
特别好写233
#include <bits/stdc++.h>
#define For(i, l, r) for(register int i = (l), i##end = (int)(r); i <= i##end; ++i)
#define Fordown(i, r, l) for(register int i = (r), i##end = (int)(l); i >= i##end; --i)
#define Set(a, v) memset(a, v, sizeof(a))
#define Cpy(a, b) memcpy(a, b, sizeof(a))
#define debug(x) cout << #x << ": " << x << endl
#define DEBUG(...) fprintf(stderr, __VA_ARGS__)
#define fir first
#define sec second
#define mp make_pair
using namespace std;
inline bool chkmin(int &a, int b) {return b < a ? a = b, 1 : 0;}
inline bool chkmax(int &a, int b) {return b > a ? a = b, 1 : 0;}
inline int read() {
int x = 0, fh = 1; char ch = getchar();
for (; !isdigit(ch); ch = getchar()) if (ch == '-') fh = -1;
for (; isdigit(ch); ch = getchar()) x = (x << 1) + (x << 3) + (ch ^ 48);
return x * fh;
}
void File() {
#ifdef zjp_shadow
freopen ("2069.in", "r", stdin);
freopen ("2069.out", "w", stdout);
#endif
}
const int N = 5010, M = 10100 * 2, inf = 0x7f7f7f7f;
int Head[N], Next[M], to[M], val[M], e = 0;
inline void add_edge(int u, int v, int w) { to[++ e] = v; Next[e] = Head[u]; Head[u] = e; val[e] = w; }
priority_queue<pair<int, int> > P;
int dis[N], S, T; bitset<N> vis;
int Dijkstra() {
Set(dis, inf); dis[S] = 0; P.push(mp(0, S)); vis.reset();
while (!P.empty()) {
int u = P.top().sec; P.pop(); if (vis[u]) continue ; vis[u] = true;
for (int i = Head[u]; i; i = Next[i]) {
int v = to[i]; if (chkmin(dis[v], dis[u] + val[i])) P.push(mp(- dis[v], v));
}
}
return dis[T];
}
struct Edge { int u, v, a, b; } lt[M];
int n, m;
void Rebuild(int cur, int flag) {
Set(Head, 0); e = 0; S = 1; T = n + 1;
For (i, 1, m) {
int u = lt[i].u, v = lt[i].v, a = lt[i].a, b = lt[i].b;
if (u == 1) {
if ((v & cur) ^ flag) add_edge(S, v, a);
else add_edge(v, T, b);
} else add_edge(u, v, a), add_edge(v, u, b);
}
}
int main () {
File();
n = read(); m = read();
For (i, 1, m) {
int u = read(), v = read(), a = read(), b = read();
if (u > v) swap(u, v), swap(a, b);
lt[i] = (Edge) {u, v, a, b};
}
int ans = inf;
for (int bit = 1; bit <= n; bit <<= 1) {
Rebuild(bit, 0), chkmin(ans, Dijkstra());
Rebuild(bit, bit), chkmin(ans, Dijkstra());
}
printf ("%d\n", ans);
return 0;
}
BZOJ 2069: [POI2004]ZAW(Dijkstra + 二进制拆分)的更多相关文章
- BZOJ 2069 POI2004 ZAW 堆优化Dijkstra
题目大意:给定一张无向图.每条边从两个方向走各有一个权值,求从点1往出走至少一步之后回到点1且不经过一条边多次的最短路 显然我们须要从点1出发走到某个和点1相邻的点上,然后沿最短路走到还有一个和点1相 ...
- BZOJ.2069.[POI2004]ZAW(最短路Dijkstra 按位划分)
题目链接 \(Description\) 给定一张带权图(边是双向的,但不同方向长度不同).求从1出发,至少经过除1外的一个点,再回到1的最短路.点和边不能重复经过. \(n\leq5000,m\le ...
- 【刷题】BZOJ 2069 [POI2004]ZAW
Description 在Byte山的山脚下有一个洞穴入口. 这个洞穴由复杂的洞室经过隧道连接构成. 洞穴的入口是一条笔直通向"前面洞口"的道路. 隧道互相都不交叉(他们只在洞室相 ...
- 2069: [POI2004]ZAW
2069: [POI2004]ZAW 链接 题意: 给定一张带权图(边是双向的,但不同方向长度不同).求从1出发,至少经过除1外的一个点,再回到1的最短路.点和边不能重复经过. n≤5000,m≤10 ...
- bzoj 2096 [POI2004]ZAW——二进制枚举
题目:https://www.lydsy.com/JudgeOnline/problem.php?id=2069 可以把直接相连的点分成 从1点出的一部分 和 走向1点的一部分.多起点最短路就和 ...
- BZOJ2069: [POI2004]ZAW
2069: [POI2004]ZAW Time Limit: 10 Sec Memory Limit: 64 MBSubmit: 303 Solved: 138[Submit][Status][D ...
- 【最短路】【dijkstra】【二进制拆分】hdu6166 Senior Pan
题意:给你一张带权有向图,问你某个点集中,两两结点之间的最短路的最小值是多少. 其实就是dijkstra,只不过往堆里塞边的时候,要注意塞进去它是从集合中的哪个起始点过来的,然后在更新某个点的答案的时 ...
- hdu 2844 coins(多重背包 二进制拆分法)
Problem Description Whuacmers use coins.They have coins of value A1,A2,A3...An Silverland dollar. On ...
- HDU 4135:Co-prime(容斥+二进制拆分)
Co-prime Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others) Total S ...
随机推荐
- 开发工程中遇到的BUG
Xcode7自带Git创建的项目"Couldn’t communicate with a helper application" git xcode7 zhunjiee 2015年 ...
- p67交换幺环为整环的充要条件
如何理解并且证明这个定理?谢谢 (0)是素理想,也是就是说,只要ab∈(0)就有a∈(0)或者b∈(0) 这等价于说 ab=0就有a=0或b=0. 它这里给的证明是什么意思呢?它是利用了素理想的等价刻 ...
- 将iso镜像转换为docker镜像
为什么不用官方的镜像? 不是不想使用,而是官方镜像提供的功能实在是太少了,不信的话,你pull一个ubuntu:latest的进行,你看有没有wget.curl.ssh这些功能,就连最简单的ifcon ...
- PHP导出CSV文件出现乱码的解决方法
在做项目时碰到使用外语的情况下,我们就会使用UTF-8编码.但是,在用PHP导出CSV文件时,如果写入的数据是使用UTF-8编码的日语.韩语之类的外文,就会出现乱码. 要解决PHP生成CSV文件的乱码 ...
- Oracle SQL优化原则
原文:http://bbs.landingbj.com/t-0-240353-1.html 1.选用适合的 ORACLE 优化器 2.访问 Table 的方式 3.共享SQL语句 共享的语句必须满足三 ...
- Day 4-2 random模块
import random random.randint(1,100) # 从1到100中随机取出一个数.包含100 random.randrange(1,100) #功能和上面一样.只是不包含100 ...
- MySQL的备份和回复
一.备份的原因 二.备份的类型 三.备份的方式 四.备份策略 五.备份工具
- 莫烦scikit-learn学习自修第一天【scikit-learn安装】
1. 机器学习的分类 (1)有监督学习(包括分类和回归) (2)无监督学习(包括聚类) (3)强化学习 2. 安装 (1)安装python (2)安装numpy >=1.6.1 (3)安装sci ...
- 莫烦keras学习自修第二天【backend配置】
keras的backend包括tensorflow和theano,tensorflow只能在macos和linux上运行,theano可以在windows,macos及linux上运行 1. 使用配置 ...
- python数学第一天【极限存在定理】
1.基本回忆 2.两边夹定理 推论1. 基本三角函数的极限 2.极限存在定理 单调有界数列必有极限 (1)单调递增有上界数列必有极限 (2)单调递减有下界数列必有极限 推论1: (1+1/n)^n有极 ...